////////////////////////////////////////////////////////////////////////////////
// main.cpp
// Vyroba vezi typu P
// Soutez v programovani, Ustredni kolo, Janske Lazne 2014
// main header file
// (c) Jan Horacek, soutezni cislo 22
// jan.horacek@seznam.cz
// 21.06.2014
// v1.0
// license: Apache license v2.0
////////////////////////////////////////////////////////////////////////////////

#ifndef MAIN_H_INCLUDED
#define MAIN_H_INCLUDED

typedef struct tmp {
    int x;
    int y;

    tmp()
    {
        x = 0;
        y = 0;
    }
    tmp(int ax, int ay)
    {
        x = ax;
        y = ay;
    }
} Point;

typedef enum { A, R, G, B, Y} Color;
typedef enum { P, D, PBDB} VezType;

Point base_size;
VezType typ_veze;

typedef struct {
    Point size;
    int cntA, cntR, cntG, cntB, cntY;
} Kostka;

#define kostky_cnt 5
Kostka kostky[kostky_cnt];
    // [0] = 2x2
    // [1] = 1x4
    // [2] = 1x3
    // [3] = 1x2
    // [4] = 1x1

typedef struct {
    int typ;
    int rotace; // 0 = zakladni, 1 = prevracena
    Color color;
    Point pos;
} MapKostka;

typedef struct {
    int map[20][20];        // 0 = prazdne misto

    int kostkyCnt;
    MapKostka kostky[400];
} Patro;

Patro patra[1000];
int patra_cnt;

#endif // MAIN_H_INCLUDED
